10 '     PROGRAM TO CONVERT AN EDIT FILE TO AN ADDRESS MANAGER DATABASE 
11 '     FILE.
12 '  
13 '     AN ADDRESS MANAGER DATABASE FILE HAS THE FOLLOWING FORMAT:
14 '             SIZE | ENTRY 1 | ENTRY 2 | ... | ENTRY N | <FF>
15 '        WHERE SIZE IS A 4 BYTE INTEGER AND EACH ENTRY HAS THE
16 '        FOLLOWING FORMAT:
17 '             <FF> NAME <CR> ADDRESS LINE 1 <CR> ADDRESS LINE 2 <CR>
18 '             ADDRESS LINE 3 <CR> AREA CODE <CR> PHONE PREFIX <CR>
19 '            LAST 4 DIGITS <CR> COMMENT LINE 1 <CR> COMMENT LINE 2
20 '        WHERE <FF> IS A FORM FEED BYTE AND <CR> IS A CARRIAGE RETURN BYTE
21 '  
22 '     THE ADDRESS MANAGER TREATS A DATABASE FILE AS A DIRECT ACCESS FILE
23 '     HAVING A RECORD LENGTH OF 512 BYTES.  THIS PROGRAM ACCESS THE FILE
24 '     64 BYTES AT A TIME FOR CONVENIENCE.
25 '------------------------------------------------------------------------
100 INPUT "Enter input ASCII file:            ",FILE1$
110 OPEN FILE1$ FOR INPUT AS #1
120 INPUT "Enter output database file:        ",FILE2$
130 OPEN FILE2$ AS #2 LEN=128
140 FIELD #2,128 AS A$
145 INPUT "Are comments lines in edit file?:  ",C$
146 CMNT$ = MID$( C$, 1, 1 ) : IF CMNT$ = "y" THEN CMNT$ = "Y"
150 '--------DEFINE THE FORM FEED CHARACTER, FF
160 FF$ = CHR$( 12 )
170 '--------DEFINE THE CARRIAGE RETURN CHARACTER, CR
180 CR$ = CHR$( 13 )
190 '   THE FIRST 5 BYTES OF THE FILE CONTAIN THE TOTAL NUMBER OF BYTES
200 '--------------------------------------------
210 X$ = MKI$( 0 )
220 C$ = X$ + X$ + FF$
230 SIZE = 5
240 IREC% = 0
300 '--------------------------------------------
305 '---------------------------ENTRY OUTPUT LOOP
310 '---------------------------NAME
320 IF EOF(1) THEN GOTO 900
330 LINE INPUT #1,X$
340 IF LEN(X$) <= 2 GOTO 320
345 PRINT X$
350 C$ = C$ + X$ + CR$
360 SIZE = SIZE + LEN(X$) + 1
370 GOSUB 1000
380 '---------------------------ADDRESS LINE 1
385 IF EOF(1) THEN X$ = "" : GOTO 395
390 LINE INPUT #1,X$
395 PRINT X$
400 C$ = C$ + X$ + CR$
410 SIZE = SIZE + LEN(X$) + 1
420 GOSUB 1000
430 '---------------------------ADDRESS LINE 2
435 IF EOF(1) THEN X$ = "" : GOTO 445
440 LINE INPUT #1,X$
445 PRINT X$
450 C$ = C$ + X$ + CR$
460 SIZE = SIZE + LEN(X$) + 1
470 GOSUB 1000
480 '---------------------------ADDRESS LINE 3
485 IF EOF(1) THEN X$ = "" : GOTO 495
490 LINE INPUT #1,X$
495 PRINT X$
500 C$ = C$ + X$ + CR$
510 SIZE = SIZE + LEN(X$) + 1
520 GOSUB 1000
530 '---------------------------PHONE LINE
535 IF EOF(1) THEN X$ = "" : GOTO 542
540 LINE INPUT #1,X$
542 PRINT X$
545 '    REMOVE EXISTING PUNCTUATION, IF ANY
550 K% = INSTR( X$, "(" ) : IF K% > 0 THEN GOSUB 590
560 K% = INSTR( X$, ")" ) : IF K% > 0 THEN GOSUB 590
570 K% = INSTR( X$, "-" ) : IF K% > 0 THEN GOSUB 590
580 GOTO 610
590    X$ = MID$( X$, 1, K%-1 ) + MID$( X$, K%+1, LEN(X$)-K% )
600    RETURN
605 '    IF RESULTING STRING IS NOT 10 LONG, IGNORE IT
610 IF LEN(X$) = 10 THEN GOTO 650
615   C$ = C$ + CR$ + CR$ + CR$
620   SIZE = SIZE + 3
630   GOTO 670
640 '    PHONE STRING IS 10 LONG:
650   C$ = C$ + MID$(X$,1,3) + CR$ + MID$(X$,4,3) + CR$ + MID$(X$,7,4) + CR$
660   SIZE = SIZE + 13
670 GOSUB 1000
680 '---------------------------COMMENT LINE 1
685 IF CMNT$ <> "Y" OR EOF(1) THEN X$ = "" : GOTO 695
690 LINE INPUT #1,X$
695 PRINT X$
700 C$ = C$ + X$ + CR$
710 SIZE = SIZE + LEN(X$) + 1
720 GOSUB 1000
730 '---------------------------COMMENT LINE 2
735 IF CMNT$ <> "Y" OR EOF(1) THEN X$ = "" : GOTO 745
740 LINE INPUT #1,X$
745 PRINT X$
750 C$ = C$ + X$ + FF$
760 SIZE = SIZE + LEN(X$) + 1
770 GOSUB 1000
780 GOTO 320
790 '---------------------------END OF LOOP
800 '--------------------------------------
900 '---------------------------WRAP UP OUTPUT FILE
910 IF LEN(C$) < 128 THEN C$ = C$ + SPACE$( 128-LEN(C$) )
920 LSET A$ = C$
930 IREC% = IREC% + 1
940 PUT #2,IREC%
945 '  NOTE:  File must be a multiple of 512 bytes (4 128-byte records)
950 K% = IREC% MOD 4
960 IF K% = 0 THEN GOTO 985
970   LSET A$ = SPACE$(128)
980   FOR I% = 1 TO 4-K% : IREC% = IREC% + 1 : PUT #2,IREC% : NEXT I%
985 PRINT "Database size is ";SIZE;" bytes"
987 IF SIZE > 32767! THEN SIZE = SIZE - 65536!
988 K% = SIZE
991 GET #2,1
992 B$ = A$
993 MID$( B$, 1, 2 ) = MKI$( K% )
994 LSET A$ = B$
995 PUT #2,1
999 END
1000 '---------------------INPUT BUFFER UPDATE ROUTINE
1010 IF LEN(C$) <= 128 THEN RETURN
1020 B$ = MID$( C$, 1, 128 )
1030 C$ = MID$( C$, 129, LEN(C$)-128 )
1040 LSET A$ = B$
1050 IREC% = IREC% + 1
1060 PUT #2,IREC%
1070 RETURN
