COMMENT *

			     CLUBware  (tm)

	  SCRLDN scrolls down a window on the screen.

		   Copyright 1984 Rayhawk Automation N.W. Inc
				  P.O. Box 1427
				  Beaverton, Oregon   97075


	  Algorithm:
		  Simply pass parameters to BIOS video AH = 6


	  CALL	  SCRLDN ( STARTY% , STARTX% , ENDY% , ENDX% , COUNT% )

		  ( STARTX% , STARTY% ) upper left corner of window

		  ( ENDX% , ENDY% ) lower right corner of window

		  1,1 is upper left corner

		  COUNT%  count of lines to scroll up
			  = 0 means blank the entire window

									      *

;______________________________________________________________________________

;  Normal assembly directives

CODE	  SEGMENT PARA PUBLIC 'CODE'

	  ASSUME  CS:CODE

	  PUBLIC  SCRLDN

;______________________________________________________________________________

SCRLDN	  PROC	  FAR

	  PUSH	  BP
	  MOV	  BP,SP
	  PUSH	  AX		       ; save all registers used,
	  PUSH	  BX		       ;  no data segment local to this
	  PUSH	  CX		       ;  routine so segment registers
	  PUSH	  DX		       ;  are untouched.


;	  ...	  1) load the input parameters into registers

	  MOV	  BX,WORD PTR [BP+6]   ; address of COUNT%
	  MOV	  AL,BYTE PTR [BX]     ; load count itself

	  MOV	  BX,WORD PTR [BP+8]   ; address of ENDX%
	  MOV	  DL,BYTE PTR [BX]
	  DEC	  DL

	  MOV	  BX,WORD PTR [BP+10]  ; address of ENDY%
	  MOV	  DH,BYTE PTR [BX]
	  DEC	  DH

	  MOV	  BX,WORD PTR [BP+12]  ; address of STARTX%
	  MOV	  CL,BYTE PTR [BX]
	  DEC	  CL

	  MOV	  BX,WORD PTR [BP+14]  ; address of STARTY%
	  MOV	  CH,BYTE PTR [BX]
	  DEC	  CH

	  MOV	  BH,07h	       ; use normal video attribute


;	  ...	  2) have BIOS scroll the window down

	  MOV	  AH,7
	  INT	  10h


	  POP	  DX
	  POP	  CX
	  POP	  BX
	  POP	  AX
	  POP	  BP
	  RET	  10


SCRLDN	  ENDP

;______________________________________________________________________________

CODE	  ENDS

	  END
